defmodule StellarBase.XDR.ContractCostType do
  @moduledoc """
  Automatically generated by xdrgen
  DO NOT EDIT or your changes may be overwritten

  Target implementation: elixir_xdr at https://hex.pm/packages/elixir_xdr

  Representation of Stellar `ContractCostType` type.
  """

  @behaviour XDR.Declaration

  @declarations [
    WasmInsnExec: 0,
    WasmMemAlloc: 1,
    HostMemAlloc: 2,
    HostMemCpy: 3,
    HostMemCmp: 4,
    InvokeHostFunction: 5,
    VisitObject: 6,
    ValXdrConv: 7,
    ValSer: 8,
    ValDeser: 9,
    ComputeSha256Hash: 10,
    ComputeEd25519PubKey: 11,
    MapEntry: 12,
    VecEntry: 13,
    GuardFrame: 14,
    VerifyEd25519Sig: 15,
    VmMemRead: 16,
    VmMemWrite: 17,
    VmInstantiation: 18,
    VmCachedInstantiation: 19,
    InvokeVmFunction: 20,
    ChargeBudget: 21,
    ComputeKeccak256Hash: 22,
    ComputeEcdsaSecp256k1Key: 23,
    ComputeEcdsaSecp256k1Sig: 24,
    RecoverEcdsaSecp256k1Key: 25,
    Int256AddSub: 26,
    Int256Mul: 27,
    Int256Div: 28,
    Int256Pow: 29,
    Int256Shift: 30
  ]

  @enum_spec %XDR.Enum{declarations: @declarations, identifier: nil}

  @type t :: %__MODULE__{identifier: atom()}

  defstruct [:identifier]

  @spec new(type :: atom()) :: t()
  def new(type \\ :WasmInsnExec), do: %__MODULE__{identifier: type}

  @impl true
  def encode_xdr(%__MODULE__{identifier: type}) do
    @declarations
    |> XDR.Enum.new(type)
    |> XDR.Enum.encode_xdr()
  end

  @impl true
  def encode_xdr!(%__MODULE__{identifier: type}) do
    @declarations
    |> XDR.Enum.new(type)
    |> XDR.Enum.encode_xdr!()
  end

  @impl true
  def decode_xdr(bytes, spec \\ @enum_spec)

  def decode_xdr(bytes, spec) do
    case XDR.Enum.decode_xdr(bytes, spec) do
      {:ok, {%XDR.Enum{identifier: type}, rest}} -> {:ok, {new(type), rest}}
      error -> error
    end
  end

  @impl true
  def decode_xdr!(bytes, spec \\ @enum_spec)

  def decode_xdr!(bytes, spec) do
    {%XDR.Enum{identifier: type}, rest} = XDR.Enum.decode_xdr!(bytes, spec)
    {new(type), rest}
  end
end
